var popupStack = new Array();
var previousPopup;
var clickActivated = 0;

$(document).ready(
  function(){
    $('div.popup-hover-activate a.popup-title').mouseover(function(event){ mouse_hover(this);});
    $('div.popup-click-activate a.popup-title').click(function(event){ mouse_click(this);});
    $('div.popup-element').css('z-index', 0);
  }
);



function show_popup(popup){

  var body = popup.children('div.popup-positioner').children('div.popup-body');

  // Move previous popup
  if (previousPopup!=null && previousPopup.get(0) != popup.get(0)){
    previousPopup.children('.popup-positioner').children('.popup-body').hide();
    previousPopup.css('position', 'static');
  }

  popup.css('position', 'relative');

  switch(true){
    case popup.hasClass('popup-effect-slide'): body.slideDown("medium"); break;
    case popup.hasClass('popup-effect-fade') : body.fadeIn("medium")   ; break;
    default: body.show();
  }
}

function hide_popup(popup){

  var body = popup.children('div.popup-positioner').children('div.popup-body');

  // Move to back
  previousPopup = popup;
  lastTimeout = setTimeout("$('#" + popup.attr('id') + "').css('position', 'static').children('.popup-positioner').children('.popup-body').hide(); previousPopup = null;", 500);

  switch(true){
    case popup.hasClass('popup-effect-slide'): body.slideUp("medium"); break;
    case popup.hasClass('popup-effect-fade'): body.fadeOut("medium"); break;
    default: body.hide(); 
  }
}



function mouse_click(title){

  var parent = $(title).parent();
  var body = parent.children('div.popup-positioner').children('div.popup-body');

  var currentDisplay = body.css('display');

  if (currentDisplay == 'block'){
    clickActivated --;
    // Undo ie z-index hack after animation completes
    setTimeout("$('#"+parent.attr('id')+"').css('zIndex', 0)", 250);
    hide_popup(parent);
  }

  if (currentDisplay == 'none'){
    clickActivated++;
    show_popup(parent);
  }
}

function mouse_hover(title){
  
  var parent = $(title).parent();
  var id = parent.attr('id');
  var body = parent.children('div.popup-positioner').children('div.popup-body');
  
  // Ignore if already shown
  for(a=popupStack.length - 1; a >= 0; a--){
    if (popupStack[a] == id) return;
    // If not related, hide last
    if (parent.parents('#' + popupStack[a]).length == 0){
      var last = popupStack.pop();
      hide_popup($('#' + last));
    }
  }
  
  popupStack.push(id);
  // Show
  show_popup(parent);
  
  if (popupStack.length == 1) $(document).mousemove(function(event){mouse_move(event)});
}

function mouse_move(event){
  var source = $(event.target);
  var id = source.attr('id');

  // Ignore if already shown
  for(a=popupStack.length - 1; a >= 0; a--){
    if (popupStack[a] == id) return;
    // If not related, hide last
    if (source.parents('#' + popupStack[a]).length == 0){
      var last = popupStack.pop();
      hide_popup($('#' + last));
    }
  }
}


